// **********************************************************************
//
// Copyright (c) 2003-2018 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.7.1
//
// <auto-generated>
//
// Generated from file `Process.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package Ice;

/**
 * An administrative interface for process management. Managed servers must
 * implement this interface.
 *
 * <p class="Note">A servant implementing this interface is a potential target
 * for denial-of-service attacks, therefore proper security precautions
 * should be taken. For example, the servant can use a UUID to make its
 * identity harder to guess, and be registered in an object adapter with
 * a secured endpoint.
 *
 **/
public interface ProcessPrx extends ObjectPrx
{
    /**
     * Initiate a graceful shut-down.
     *
     * @see Communicator#shutdown
     *
     **/
    public void shutdown();

    /**
     * Initiate a graceful shut-down.
     *
     * @see Communicator#shutdown
     *
     * @param context The Context map to send with the invocation.
     **/
    public void shutdown(java.util.Map<String, String> context);

    /**
     * Initiate a graceful shut-down.
     *
     * @return The asynchronous result object.
     **/
    public AsyncResult begin_shutdown();

    /**
     * Initiate a graceful shut-down.
     *
     * @param context The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public AsyncResult begin_shutdown(java.util.Map<String, String> context);

    /**
     * Initiate a graceful shut-down.
     *
     * @param cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_shutdown(Callback cb);

    /**
     * Initiate a graceful shut-down.
     *
     * @param context The Context map to send with the invocation.
     * @param cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_shutdown(java.util.Map<String, String> context, Callback cb);

    /**
     * Initiate a graceful shut-down.
     *
     * @param cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_shutdown(Callback_Process_shutdown cb);

    /**
     * Initiate a graceful shut-down.
     *
     * @param context The Context map to send with the invocation.
     * @param cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_shutdown(java.util.Map<String, String> context, Callback_Process_shutdown cb);

    /**
     * Initiate a graceful shut-down.
     *
     * @param responseCb The lambda response callback.
     * @param exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_shutdown(IceInternal.Functional_VoidCallback responseCb,
                                          IceInternal.Functional_GenericCallback1<Exception> exceptionCb);

    /**
     * Initiate a graceful shut-down.
     *
     * @param responseCb The lambda response callback.
     * @param exceptionCb The lambda exception callback.
     * @param sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_shutdown(IceInternal.Functional_VoidCallback responseCb,
                                          IceInternal.Functional_GenericCallback1<Exception> exceptionCb,
                                          IceInternal.Functional_BoolCallback sentCb);

    /**
     * Initiate a graceful shut-down.
     *
     * @param context The Context map to send with the invocation.
     * @param responseCb The lambda response callback.
     * @param exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_shutdown(java.util.Map<String, String> context,
                                          IceInternal.Functional_VoidCallback responseCb,
                                          IceInternal.Functional_GenericCallback1<Exception> exceptionCb);

    /**
     * Initiate a graceful shut-down.
     *
     * @param context The Context map to send with the invocation.
     * @param responseCb The lambda response callback.
     * @param exceptionCb The lambda exception callback.
     * @param sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_shutdown(java.util.Map<String, String> context,
                                          IceInternal.Functional_VoidCallback responseCb,
                                          IceInternal.Functional_GenericCallback1<Exception> exceptionCb,
                                          IceInternal.Functional_BoolCallback sentCb);

    /**
     * Initiate a graceful shut-down.
     *
     * @param result The asynchronous result object.
     * @see Communicator#shutdown
     *
     **/
    public void end_shutdown(Ice.AsyncResult result);

    /**
     * Write a message on the process' stdout or stderr.
     *
     * @param message The message.
     *
     * @param fd 1 for stdout, 2 for stderr.
     *
     **/
    public void writeMessage(String message, int fd);

    /**
     * Write a message on the process' stdout or stderr.
     *
     * @param message The message.
     *
     * @param fd 1 for stdout, 2 for stderr.
     *
     * @param context The Context map to send with the invocation.
     **/
    public void writeMessage(String message, int fd, java.util.Map<String, String> context);

    /**
     * Write a message on the process' stdout or stderr.
     *
     * @param message The message.
     *
     * @param fd 1 for stdout, 2 for stderr.
     *
     * @return The asynchronous result object.
     **/
    public AsyncResult begin_writeMessage(String message, int fd);

    /**
     * Write a message on the process' stdout or stderr.
     *
     * @param message The message.
     *
     * @param fd 1 for stdout, 2 for stderr.
     *
     * @param context The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public AsyncResult begin_writeMessage(String message, int fd, java.util.Map<String, String> context);

    /**
     * Write a message on the process' stdout or stderr.
     *
     * @param message The message.
     *
     * @param fd 1 for stdout, 2 for stderr.
     *
     * @param cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_writeMessage(String message, int fd, Callback cb);

    /**
     * Write a message on the process' stdout or stderr.
     *
     * @param message The message.
     *
     * @param fd 1 for stdout, 2 for stderr.
     *
     * @param context The Context map to send with the invocation.
     * @param cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_writeMessage(String message, int fd, java.util.Map<String, String> context, Callback cb);

    /**
     * Write a message on the process' stdout or stderr.
     *
     * @param message The message.
     *
     * @param fd 1 for stdout, 2 for stderr.
     *
     * @param cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_writeMessage(String message, int fd, Callback_Process_writeMessage cb);

    /**
     * Write a message on the process' stdout or stderr.
     *
     * @param message The message.
     *
     * @param fd 1 for stdout, 2 for stderr.
     *
     * @param context The Context map to send with the invocation.
     * @param cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_writeMessage(String message, int fd, java.util.Map<String, String> context, Callback_Process_writeMessage cb);

    /**
     * Write a message on the process' stdout or stderr.
     *
     * @param message The message.
     *
     * @param fd 1 for stdout, 2 for stderr.
     *
     * @param responseCb The lambda response callback.
     * @param exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_writeMessage(String message,
                                              int fd,
                                              IceInternal.Functional_VoidCallback responseCb,
                                              IceInternal.Functional_GenericCallback1<Exception> exceptionCb);

    /**
     * Write a message on the process' stdout or stderr.
     *
     * @param message The message.
     *
     * @param fd 1 for stdout, 2 for stderr.
     *
     * @param responseCb The lambda response callback.
     * @param exceptionCb The lambda exception callback.
     * @param sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_writeMessage(String message,
                                              int fd,
                                              IceInternal.Functional_VoidCallback responseCb,
                                              IceInternal.Functional_GenericCallback1<Exception> exceptionCb,
                                              IceInternal.Functional_BoolCallback sentCb);

    /**
     * Write a message on the process' stdout or stderr.
     *
     * @param message The message.
     *
     * @param fd 1 for stdout, 2 for stderr.
     *
     * @param context The Context map to send with the invocation.
     * @param responseCb The lambda response callback.
     * @param exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_writeMessage(String message,
                                              int fd,
                                              java.util.Map<String, String> context,
                                              IceInternal.Functional_VoidCallback responseCb,
                                              IceInternal.Functional_GenericCallback1<Exception> exceptionCb);

    /**
     * Write a message on the process' stdout or stderr.
     *
     * @param message The message.
     *
     * @param fd 1 for stdout, 2 for stderr.
     *
     * @param context The Context map to send with the invocation.
     * @param responseCb The lambda response callback.
     * @param exceptionCb The lambda exception callback.
     * @param sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_writeMessage(String message,
                                              int fd,
                                              java.util.Map<String, String> context,
                                              IceInternal.Functional_VoidCallback responseCb,
                                              IceInternal.Functional_GenericCallback1<Exception> exceptionCb,
                                              IceInternal.Functional_BoolCallback sentCb);

    /**
     * Write a message on the process' stdout or stderr.
     *
     * @param result The asynchronous result object.
     **/
    public void end_writeMessage(Ice.AsyncResult result);
}
